// (c) 2022 cepstrum.co.jp           //
// This is not free software.        //
//
// FIR filter speed test
//

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <math.h>
#include <time.h>

#define ITERATE 300000
#define FIRLEN  100000

float  h[FIRLEN];
float  xbuf[FIRLEN];
float  y;
float  x;

time_t start_time;
time_t finish_time;

int    i;
char   c;

//--------------------------------------------
// conventional FIR filter

float fir(float x, float xbuf[], float coef[], int length) {
  int   ix;
  float y;

  for (ix=length-1; 1<=ix; ix=ix-1) xbuf[ix]=xbuf[ix-1];
  xbuf[0]=x;
  y=0.0;
  for (ix=0; ix<length; ix=ix+1) y=y+xbuf[ix]*coef[ix];
  return y;
}

//--------------------------------------------

int main() {

  for (i=0; i<FIRLEN; i=i+1) {
    h[i]=(float)rand()/(float)RAND_MAX-0.5;
    xbuf[i]=0.0;
  }

  fprintf(stderr, "running %iloop %itap FIR filter\n", ITERATE, FIRLEN);
  fprintf(stderr, "please wait...\n");

  start_time=time(NULL);
  for (i=0; i<ITERATE; i=i+1) {
    x=(float)rand()/(float)RAND_MAX-0.5;
    y=fir(x, xbuf, h, FIRLEN);
    if (i%(int)(ITERATE/75)==0) {
      fprintf(stderr, "*");
    }
  }
  fprintf(stderr, "\n");
  finish_time=time(NULL);

  fprintf(stderr, "%i[sec]\n", (int)difftime(finish_time, start_time));
  fprintf(stderr, "hit retun key to exit");
  scanf("%c", &c);

}


